#include <stdio.h>
//#include <conio.h>

FILE *fin, *fout;

int a[12][12];

int build() {
    int i, j;

    for ( i = 1; i <= 11; ++i )
        a[1][i] = a[i][1] = (i % 2 ? 0 : 1 );
    i = 2;
    a[i][i] = 2;
    for ( j = 3; j <= 11; ++j ) {
        a[i][j] = a[i][j-1] + a[i][j-2];
        a[j][i] = a[j-1][i] + a[j-2][i];
    }
    for ( i = 3; i <= 11; ++i ) {
        a[i][i] = ( i * i % 2 ? 0 : a[i-1][i] + a[i-2][i] );
        for ( j = i + 1; j <= 11; ++j ) {
            a[i][j] = ( (i * j) % 2 ? 0 : a[i-1][j] + a[i-2][j] );
            a[j][i] = ( (i * j) % 2 ? 0 : a[j][i-1] + a[j][i-2] );
        }
    }
}

void print_all() {
     int i, j;
     for ( i = 1; i <= 11; ++i ) {
         for ( j = 1; j <= 11; ++j )
             printf("%4d ", a[i][j]);
         printf("\n");
     }
}

int main() {
    int w, h;

    fin = fopen("build.inp", "r");
    fout = fopen("build.out", "w");
    build();
    while(fscanf(fin, "%d%d", &w, &h) != -1) {
        fprintf(fout, "%d\n", a[w][h]);
    }
    fclose(fin);
    fclose(fout);
    return 0;
}
