#include <stdio.h>
#include <stdlib.h>

#define N 170

#define min(a,b) ((a>b)?b:a)

int n;
int neigh[N][N];
int labl[N];
int num[N];
int curnum;
int mass[N][2];
int cur;

void dfs(int u, int v)
{
  int i;
  curnum++;
  num[u]=curnum;
  labl[u]=curnum;

  for(i=1; i<=neigh[u][0]; i++)
  {
    if(num[neigh[u][i]] == 0)
    {
      dfs(neigh[u][i], u);
      labl[u] = min(labl[u], labl[neigh[u][i]]);
    }
    else if(neigh[u][i]!=v)
      labl[u] = min(labl[u], num[neigh[u][i]]);
  }

  if(labl[u]>=num[u] && v!=-1)
  {
    u++;v++;
    mass[cur][0] = min(u,v);
    mass[cur][1] = u+v-mass[cur][0];
    cur++;
  }
}

int main(void)
{
  int i,j;
  freopen("routes.inp", "r", stdin);
  freopen("routes.out", "w", stdout);

  scanf("%d\n", &n);
  for(i=0; i<n; i++)
  {
    int x,y,z;
    scanf("%d ", &z);

    for(j=0; j<z; j++)
    {
      scanf("%d ", &x);
      x--;
      neigh[x][0]++;
      neigh[i][0]++;
      neigh[x][neigh[x][0]] = i;
      neigh[i][neigh[i][0]] = x;
    }
  }

  dfs(0, -1);

  for(i=0; i<cur-1;i++)
    for(j=i+1; j<cur; j++)
      if(mass[j][0]<mass[i][0] || (mass[j][0]==mass[i][0] && mass[j][1] < mass[i][1]) )
      {
        int x;
        x = mass[i][0];
        mass[i][0]=mass[j][0];
        mass[j][0]=x;

        x = mass[i][1];
        mass[i][1]=mass[j][1];
        mass[j][1]=x;
      }

  for(int i=0; i<cur-1; i++)
    printf("%d %d\n", mass[i][0], mass[i][1]);

  printf("%d %d", mass[cur-1][0], mass[cur-1][1]);

  fclose(stdin);
  fclose(stdout);
  return 0;
}
