Const
        InFile = 'routes.inp';
        OutFile = 'routes.out';

        MAXN = 200;

Type
        PNode = ^TNode;
        TNode = record
            id : Integer;
            next : PNode;
        end;

        TGraph = array [1..MAXN] of PNode;
        TDaga = record
           x,y : integer;
        end;

Var
        FIn,FOut  : Text;
        LOW,NUM   : array [1..MAXN] of integer;
        dagi      : array [1..10000] of TDaga;
        dagiN     : integer;
        count     : integer;
        g         : TGraph;
        n,i,j,k,l : integer;

procedure connect(i,j : integer);
var
    w : PNode;

begin
    new(W);
    w^.id := j;
    w^.next := g[i];
    g[i] := w;
end;

function min(a,b : integer):integer;
begin
    if a < b then
        min := a
    else
        min := b;
end;

procedure swap(var a,b : TDaga);
var
   temp : TDaga;
begin
   temp := a;
   a := b;
   b := temp;
end;

procedure QSort(i,j : integer);
var
   k,l : integer;
   n   : TDaga;

begin
   n := dagi[ (i + j) div 2];
   k := i;
   l := j;
   while (k <= l) do begin
      while (dagi[k].x < n.x) or ( (dagi[k].x = n.x) and (dagi[k].y < n.y)) do
            inc(k);
      while (dagi[l].x > n.x) or ( (dagi[l].x = n.x) and (dagi[l].y > n.y)) do
            dec(l);
      if (k <= l) then begin
         swap(dagi[k],dagi[l]);
         inc(k); dec(l);
      end;
   end;
   if k < j then
        QSort(k,j);
   if l > i then
        QSort(i,l);
end;

procedure obhodi(id , father : Integer);
var
    w : PNode;

begin
    inc(count);
    num[id] := count; low[id] := count;
    w := g[id];
    while w <> nil do begin
        if num[w^.id] = 0 then begin
           obhodi(w^.id,id);
           if low[w^.id] > num[id] then begin
               inc(dagiN);
               if id < w^.id then begin
                  dagi[ dagiN].x := id;
                  dagi[ dagiN].y := w^.id;
               end
               else begin
                  dagi[ dagiN].x := w^.id;
                  dagi[ dagiN].y := id;
               end;
           end;
           low[id] := min(low[id],low[w^.id]);
        end
        else begin
           if w^.id <> father then
             low[id] := min(low[id],num[w^.id]);
        end;
        w := w^.next;
    end;
end;

procedure solve;
begin
    fillchar(num,sizeof(num),0);
    fillchar(low,sizeof(low),0);
    count := 0; dagiN := 0;
    obhodi(1,0);
    if dagiN > 1 then
       QSort(1,dagiN);
    for i := 1 to dagiN do
      writeln(FOut,dagi[i].x,' ',dagi[i].y);
end;

Begin
    assign(FIn,InFile);         reset(FIn);
    assign(FOut,OutFile);       rewrite(FOut);
    readln(FIn,N);
    for i := 1 to N do begin
       read(FIn,K);
       for l := 1 to k do begin
          read(FIn,J);
          connect(i,j);
       end;
    end;
    close(FIn);
    solve;
    close(FOut);
End.