#include<fstream.h>
//#include<stdlib.h>
#include<math.h>

const char inf[30]="fence.inp", outf[30]="fence.out";
const int maxN=1000;
ifstream fin(inf);
ofstream fout(outf);

struct ctow
{
   double x,y,r;
};

ctow t[maxN];
int nt;

struct cline{
   double a,b,c,ang;
};

cline setline(double x1,double y1,double x2,double y2)
{
   cline res;
   res.a=y2-y1;
   res.b=x1-x2;
   res.c=x2*y1-x1*y2;
/*   if(res.a==0) res.ang=0;
   else if(res.b==0) res.ang=M_PI/2;
   else
   {
      res.ang=atan(-a/b);
      if(res.ang<0) res.ang+=M_PI;
   }  */
}

void finddopirs(ctow c1,ctow c2,cline& d1, cline &d2, double l)
{
   double r1=c1.r>c2.r?c1.r:c2.r;
   double r2=c1.r+c2.r-r1;
   double d=sqrt(pow(c1.x-c2.x,2)+pow(c1.y-c2.y,2));
   double ang,sang;
   sang=(r1-r2)/d;
   ang=asin(sang);
   cline l1;
/*   l1=setline(c1.x,c1.y,c2.x,c2.y);
   d1.ang=ang+l1.ang; if(d1.ang>M_PI) d1.ang-=M_PI;
   d2.ang=ang-l1.ang; if(l1.a.ang<0) d2.ang+=M_PI;
   l=d*fabs(cos(ang));*/
}

int main()
{
   nt=0;
   while(!fin.eof())
   {
      fin>>t[nt].x; if(fin.eof()) break; fin>>t[nt].y>>t[nt].r;
      nt++;
   }
   double res=2*M_PI*t[0].r;
   int r2; r2=(int)floor(res);
   res*=100;
   fout<<r2<<'.'<<(int)floor(res)%100;
   fin.close();
   fout.close();
   return 0;
}
