#include <stdio.h>

FILE *fn;
int n;
int neis[256];
int nei[256][256];
int lev[256];
int fat[256];
int minn[256];
int brid[256];
int ans[256][2];
int rans[256][2];
int anses=0;
int mans[256];

int dfs(int a, int b) {
  int i;

  lev[a]=b;
  minn[a]=b+1;
  for (i=0; i<neis[a]; i++) if (nei[a][i] != fat[a]) {
    if (lev[nei[a][i]]>0) {
      if (lev[nei[a][i]]<minn[a]) minn[a]=lev[nei[a][i]];
    } else {
      fat[nei[a][i]]=a;
      dfs(nei[a][i], b+1);
    }
  }
}

int main(void) {
int i, j, k, cbest, c0, c1;

fn=fopen("ROUTES.INP", "r");
fscanf(fn, "%d", &n);
for (i=1; i<=n; i++) {
  fscanf(fn, "%d", &neis[i]);
  for (j=0; j<neis[i]; j++) fscanf(fn, "%d", &nei[i][j]);
}
fclose(fn);

dfs(1, 1);

for (i=2; i<=n; i++) {
  if (minn[i]<lev[i]) {
    j=minn[i];
    k=i;
    while (lev[k]>j) {
      brid[k]=1;
      k=fat[k];
    }
  }
}

for (i=2; i<=n; i++) {
  if (!brid[i]) {
    if (i<fat[i]) {
      ans[anses][0]=i;
      ans[anses][1]=fat[i];
    } else {
      ans[anses][0]=fat[i];
      ans[anses][1]=i;
    }
    anses++;
  }
}

for (i=0; i<anses; i++) {
  c0=n+1;
  for (j=0; j<anses; j++) {
    if ((!mans[j]) && (ans[j][0]<c0 || (ans[j][0]==c0 && ans[j][1]<c1))) {
      cbest=j;
      c0=ans[j][0];
      c1=ans[j][1];
    }
  }
  rans[i][0]=ans[cbest][0];
  rans[i][1]=ans[cbest][1];
  mans[cbest]=1;
}

fn=fopen("ROUTES.OUT", "w");
for (i=0; i<anses; i++) {
  fprintf(fn, "%d %d\n", rans[i][0], rans[i][1]);
}
fclose(fn);

return 0;
}
