{by virus}
const  infile = 'fence.inp';
      outfile = 'fence.out';
         MaxN = 1000;
          eps = 0.0001;

type    Coola = record
                x,y,r : real;
                end;
      CoolArr = array [1..MaxN] of Coola;
          Arr = array [1..MaxN+2] of integer;
          rrr = array [1..maxn] of real;
          PSa = array [1..MaxN] Of Boolean;


       TPoint = record
                x,y : real;
                end;
        TLine = record
                a,b: Tpoint
                end;

var n : Integer;
 B, A : Coolarr;
  Sol : Real;
   HW : Boolean;
    v : rrr;
   PS : PSa;
bnu,nu: integer;
 U,BU : arr;

Function ArcSinCos(x,y: real):real;
 var z1,z2:extended;
 begin
 z1:=x;
 z2:=y;
 asm
 fld [z2]
 fld [z1]
 fpatan
 fstp [z1]
 end;
 if z1<0 then z1:=z1+2*pi;
 arcSinCos:=z1;
 end;


Procedure InX;
 var t: text;
 begin
 n:=0;
 assign(t, infile);
 reset(t);
 while not seekeof(t) do
  begin
  inc(n);
  readln(t,a[n].x,a[n].y,a[n].r);
  end;
 close(t);
 end;

Function eq(a,b :real):Boolean;
 begin
 eq:=(abs(a-b)<eps);
 end;

function ArcSin(a: real):real;
 begin
 ArcSin:=ArcTan (a/sqrt (1-sqr (a)));
 end;

Procedure Analyse(var a,b : Coola; var m,alpha : real);
 var d,x,l,s:real;
     c : coola;
 begin
 if eq(a.r,b.r) then
  begin
  m:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
  alpha:=pi/2;
  exit;
  end;
 if a.r>b.r then
  begin
  c:=a;
  a:=b;
  b:=c;
  end;
 d:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
 x:=(d*a.r)/(b.r-a.r);
 l:=sqrt(x*x-sqr(a.r));
 s:=sqrt(sqr(d+x)-sqr(b.r));
 m:=s-l;
 alpha:=arcsin(l/x);
 end;

Function CalcAngl(i,j: integer):real;
 begin
 CalcaNgl:=arcSinCos(a[j].x-a[i].x,a[j].y-a[i].y);
 end;

Function SumOf(U:Arr;n:integer):real;
 var lastalpha,newalpha: real;
     path:real;
     i,j: integer;
 begin
 path:=0.0;
 inc(n,2);
 u[n-1]:=u[1];
 u[n]:=u[2];
 lastalpha:=calcangl(u[1],u[2]);
 for i:=1 to n-1 do
  begin
  newalpha:=calcangl(u[i],u[i+1]);
  path:=path+abs(newalpha-lastalpha)*a[u[i]].r;
  j:=i+1;
  path:=path+sqrt((sqr(a[u[i]].x-a[u[j]].x)+sqr(a[u[i]].y-a[u[j]].y)) - sqr(a[u[i]].r-a[u[j]].r));
  lastalpha:=newalpha;
  end;
 dec(n,2);
 analyse(a[u[1]],a[u[2]],lastalpha,newalpha);
 path:=path-lastalpha;
 sumOf:=path;
 end;

Procedure SParse;           {tiny parser for some special cases (n<3)}
 var m,alpha: real;
 begin
 if n=1 then
  begin
  sol := a[1].r*2*pi;
  HW:=FALSE;                {parser has done the job}
  end;
 if n=2 then
  begin
  analyse(a[1],a[2],m,alpha);
  sol:=2*m + 2*alpha*(a[1].r+a[2].r);
  HW:=FALSE;                {parser has done the job}
  end;
 end;


Procedure OutX;
 var t:text;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t,sol:1:2);
 close  (t);
 end;

Procedure SillyDoWork;
 var u: arr;
     i : integer;
 begin
 for i:=1 to n do u[i]:=i;
 sol:=SumOf(u,n);
 end;

Procedure SW(i,j : integer);
 var c : Coola;
     r : real;
 begin
 c:=a[i];
 a[i]:=a[j];
 a[j]:=c;
 r:=v[i];
 v[i]:=v[j];
 v[j]:=r;
 end;

Procedure QS(L,R: integer);
 var i,j : integer;
     f : boolean;
 begin
 if l>=r then exit;
 i:=l;
 j:=r;
 f:=TRUE;
 while i<j do
  begin
  while (i<j) and (v[i]>=v[j]) do if f then dec(j) else inc(i);
  sw(i,j);
  f:= not f;
  end;
 if i>l then qs(l,i-1);
 if i<r then qs(i+1,r);
 end;

Procedure SW1(i,j : integer);
 var c : Coola;
     r : real;
 begin
 c:=b[i];
 b[i]:=b[j];
 b[j]:=c;
 r:=v[i];
 v[i]:=v[j];
 v[j]:=r;
 end;

Procedure QS1(L,R: integer);
 var i,j : integer;
     f : boolean;
 begin
 if l>=r then exit;
 i:=l;
 j:=r;
 f:=TRUE;
 while i<j do
  begin
  while (i<j) and (v[i]<=v[j]) do if f then dec(j) else inc(i);
  sw1(i,j);
  f:= not f;
  end;
 if i>l then qs(l,i-1);
 if i<r then qs(i+1,r);
 end;



function calc(a,b: TPoint):real;
 begin
 calc:=arcsincos(b.x-a.x,b.y-a.y)+2*pi;
 end;

function calcg(a,b: coola):real;
 begin
 calcg:=arcsincos(b.x-a.x,b.y-a.y)+2*pi;
 end;


function inrange(a,b,c:real):boolean;
 begin
 inrange:=(a>b) and (a<c);
 end;

function dissect(a,b: tline):Boolean;
 var e1,e2: real;
 begin
 dissect:=FALSE;
 e1:=calc(a.a,a.b);
 e2:=calc(b.a,b.b);
 if eq(e1,e2) then exit;
 if inrange(calc(a.a,b.a),e1,e1+pi) xor inrange(calc(a.a,b.b),e1,e1+pi) then
  if inrange(calc(b.a,a.a),e2,e2+pi) xor inrange(calc(b.a,a.b),e2,e2+pi) then Dissect:=TRUE;
 end;

function min(a,b:real):real;
 begin
 if a<b then min:=a else min:=b;
 end;

function max(a,b:real):real;
 begin
 if a>b then max:=a else max:=b;
 end;


function tInt(k,a,b,c: TPoint):Boolean;
 var e1,e2,e3,e4:real;
 begin
 e1:=min(calc(a,b),calc(a,c));
 e2:=max(calc(a,b),calc(a,c));
 e3:=min(calc(b,a),calc(b,c));
 e4:=max(calc(b,a),calc(b,c));

 tInt:=(inrange(calc(a,k),e1,e2) and inrange(calc(b,k),e3,e4));
 end;


Function makescheck: boolean;
 var mx,m1,m2,e: Tline;
     alpha: real;
     i: integer;
     k :tpoint;
 begin
 alpha:=arcsincos(a[2].x-a[1].x,a[2].y-a[1].y);
 alpha:=alpha+pi/2;
 m1.a.x:=a[1].x+cos(alpha)*a[1].r;
 m1.a.y:=a[1].y+sin(alpha)*a[1].r;
 m1.b.x:=a[2].x+cos(alpha)*a[2].r;
 m1.b.y:=a[2].y+sin(alpha)*a[2].r;
 m2.a.x:=a[1].x+cos(alpha+pi)*a[1].r;
 m2.a.y:=a[1].y+sin(alpha+pi)*a[1].r;
 m2.b.x:=a[2].x+cos(alpha+pi)*a[2].r;
 m2.b.y:=a[2].y+sin(alpha+pi)*a[2].r;
 for i:=3 to n do
  begin
  k.x:=a[i].x;
  k.y:=a[i].y;
  if (not tINt(k,m1.a,m1.b,m2.a)) and (not tint(k,m2.a,m1.b,m2.b)) then
   begin
   makescheck:=FALSE;
   exit;
   end;

  end;
 for i:=3 to n do
  begin
  e.a.x:=a[i].x+cos(alpha)*a[i].r;
  e.a.y:=a[i].y+sin(alpha)*a[i].r;
  e.b.x:=a[i].x+cos(alpha+pi)*a[i].r;
  e.b.y:=a[i].y+sin(alpha+pi)*a[i].r;
  if dissect(e,m1) or dissect(e,m2) then
   begin
   makescheck:=FALSE;
   exit;
   end;
  end;


 makescheck:=TRUE;
 end;

Function psAll: boolean;
 var i : longint;
 begin
 for i:=1 to n do if not ps[i] then
  begin
  psAll:=FALSE;
  exit;
  end;
 psAll:=TRUE;
 end;

var flag: boolean;

Function errrange: integer;
 var i,j,k: integer;
     r1,r2: real;
 begin
 errrange:=0;

 for i:=1 to nu do
  begin
  r1:= 999999;
  for j:=1 to nu do if j<>i then if calcg(a[u[i]],a[u[j]])<r1 then r1:=calcg(a[u[i]],a[u[j]]);
  r1:=-999999;
  for j:=1 to nu do if j<>i then if calcg(a[u[i]],a[u[j]])>r2 then r2:=calcg(a[u[i]],a[u[j]]);
  for j:=1 to n do if not(ps[j]) then if not inrange(calcg(a[u[i]],a[j]),r1,r2) then
   begin
   errrange:=j;
   exit;
   end;
  end;
 end;

Procedure track(node: integer);
 var K : integer;
 begin
 if flag then exit;
 inc(nu);
 u[nu]:=Node;
 ps[node]:=TRUE;
 k:= errrange;
 if k=0 then
  begin
  flag:=TRUE;
  BU:=U;
  bnu:=nu;
  exit;
  end;
 if k>node then track(k);
 ps[node]:=FALSE;
 dec(nu);
 end;


Procedure DoWork; {not much smarter than the SillyDoWork, but hopefully enough smarter ...:)}
 var  mx,my : real;
      i,j,k,l : integer;
      m,alpha : real;
      f : boolean;
      z: coola;
 begin
 mx:=0; my :=0;
 for i:=1 to n do
  begin
  mx:=mx + a[i].x;
  my:=my + a[i].y;
  end;
 mx:=mx/n;
 my:=my/n;
 z.x:=mx;
 z.y:=my;
 z.r:=0;
 for i:=1 to n do v[i]:=sqrt(sqr(a[i].x-mx)+sqr(a[i].y-my));
 qs(1,n);
 {coolas are now sorted by their distance from the midpoint}
 PS[1]:=TRUE;
 PS[2]:=TRUE;
 u[1]:=1;
 u[2]:=2;
 if makescheck then
  begin
  analyse(a[1],a[2],m,alpha);
  sol:=2*m + 2*alpha*(a[1].r+a[2].r);
  exit;
  end;
 nu:=2;
 for i:=3 to n do track(i);
 for i:=1 to bnu do b[i]:=a[bu[i]];
 for i:=1 to bnu do v[i]:=calcg(z,b[i]);
 qs1(1,bnu);
 for i:=1 to bnu do bu[i]:=i;
 sol:=sumof(BU,bnu);

 end;


BEGIN
Sol:=0;
hW:=TRUE;
InX;
SParse;
if HW then DOWork;     { run the sophisticated procedure only if the parser hasn't done anything.}
OutX;
END.