#include <stdio.h>

int n;
int road[170][170];
int pts[170];

int sta[171];
int stabr,pt;

void run(int pt,int from)
{
  int i,j;

  sta[stabr] = pt;
  stabr++;
  if (pts[pt])
  {
     // this is a cycle
     for (i=0;i<stabr;i++)
     {
       if (sta[i]==pt) { j=i; break; }
     }

     for (i=j+1;i<stabr;i++)
     {
       road[sta[i-1]][sta[i]]=2;
       road[sta[i]][sta[i-1]]=2; // Tova e veche dvoen pat
     }
  } else
  {
    pts[pt]=1;

    for (i=0;i<n;i++)
    {
      if (i!=from)
      {
        if (road[pt][i]==1)
        {
          run(i,pt); // Go trough
        }
      }
    }
    pts[pt]=0; // veche ne e posetena
  }
  stabr--; // mahame ot steka
  return;
}

int main(void)
{
  FILE* f;
  int i,j,k,l;
  f = fopen("routes.inp","rt");
  fscanf(f,"%d",&n);
  for (i=0;i<n;i++)
  {
    fscanf(f,"%d",&k);
    for (j=0;j<k;j++)
    {
      fscanf(f,"%d",&l);
      l--;
      road[i][l] = 1;
      road[l][i] = 1;
    }
  }
  stabr=0;
  run(0,0);

  f = fopen("routes.out","wt");
  for (i=0;i<n;i++)
  {
     for (j=i+1;j<n;j++)
     {
       if (road[i][j]==1)
       {
          fprintf(f,"%d %d\n",i+1,j+1);
       }
     }
  }
  fclose(f);

  return 0;
}
