
  Type Streets = Array [1..170,1..170] of Boolean;

  Var Fin, Fout  : Text;
      N          : Integer;
      Path,Path2 : Streets;

  Procedure Init;
      Var Q,W,E,R : Integer;
    Begin
      Assign (Fin, 'Routes.Inp');
      Reset (Fin);
      Readln (Fin,N);
      For Q:=1 To N Do
        For W:=1 To N Do
          Path[Q,W]:=False;
      For Q:=1 To N Do
        Begin
          Read (Fin,W);
          For E:=1 To W Do
            Begin
              Read (Fin,R);
              Path[R,Q]:=True;
              Path[Q,R]:=True;
            End;
        End;
      Close (Fin);
      Assign (Fout, 'Routes.out');
      Rewrite (Fout);
    End;

  Procedure PathOut (A,B : ShortInt);
    Begin
      If A<B Then Writeln (Fout, A,' ',B) Else Writeln (Fout, B, ' ',A);
    End;

  Procedure MakePath2 (C1,C2 : Integer);
      Var Q,W,E,C : Integer;
    Begin
      Path2:=Path;
      Path2[C1,C2]:=False;
      Path2[C2,C1]:=False;
      For C := 1 To N Do
        For Q := 1 To N Do
          For W := 1 To N Do
            For E:= 1 To N Do
              If Path2[Q,E] And Path2[W,E] And (Q<>W) And (Q<>E) And (W<>E) Then Path2[Q,W]:=True;
    End;

  Procedure Check;
      Var CR1,CR2,T : Integer;
          Removable : Boolean;
    Begin
      For CR1 := 1 To N Do
        For CR2 := CR1 To N Do
          Begin
            Removable:=True;
            MakePath2 (CR1,CR2);
            For T := 1 To N Do
              If Path2[CR1,T] And Path2[Cr2,T] Then Removable:=False;
            If Removable Then PathOut(CR1,CR2);
          End;
    End;

BEGIN
  Init;
  Check;
  Close (Fout);
END.