const inp = 'routes.inp';
      out = 'routes.out';

type  data = byte;
      Pnode = ^Tnode;
      TNode = record
              p: Pnode;
              d: data;
              end;
      TGrid = array[1..170, 1..170] of boolean;
      TEdges = array[1..170, 0..170] of byte;
      TFlag = array[1..170] of boolean;

var f1, f2: text;
    first, last, p: Pnode;
    n: data;
    conn, resh: TGrid;
    Edge: TEdges;
    Flag: TFlag;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
Procedure Done;
var i, j: data;

begin
for i:= 1 to n-1 do  for j:= i+1 to n do  if resh[i,j] then
  writeln(f2, i, ' ', j);
close(f1); close(f2);
halt;
end;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
Procedure Add(d: data);
begin
p:= new(PNode);
p^.d:= d;
p^.p:= nil;
last^.p:= p;
last:= p;
end;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
Procedure Get(var  d: data);
begin
p:= first^.p;
d:= p^.d;
first^.p:= p^.p;
if p=last then last:= first;
dispose(p);
end;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
Function Unpossible(i,j: data): boolean;
var p, l: data;

  procedure ClearTale;
    begin
    while first<>last do get(p);
    end;

begin
fillchar(flag, sizeof(flag), false);
Add(i); flag[i]:= true;
while first <> last do
  begin
  get(p);
  for l:=1 to n do if (conn[l, p])and(not flag[l]) then
    begin
    flag[l]:= true;
    if l=j then begin ClearTale; break; end;
    add(l);
    end;
  end;

if not flag[j] then unpossible:= true else unpossible:= false;
end;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
Procedure Solve;
var i, j, k: data;

begin
first:= new(PNode);
first^.d:= 0;
first^.p:=nil;
last:= first;

for i:=1 to n do
  begin
  if edge[i, 0] = 1 then
    begin
    resh[i, edge[i, 1]]:= true;
    resh[edge[i, 1], i]:= true;
    continue;
    end;
  for k:= 1 to edge[i, 0] do  if edge[i, k] > i then
    begin
    j:= edge[i, k];
    conn[i, j]:= false;
    conn[j, i]:= false;
    if unpossible(i,j) then resh[i, j]:= true;
    conn[i, j]:= true;
    conn[j, i]:= true;
    end;
  end;
dispose(first);
end;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
procedure Init;
var i, j, a: data;

begin
assign(f1, inp); reset(f1);
assign(f2, out); rewrite(f2);
readln(f1, n);
fillchar(conn, sizeof(conn), false);
fillchar(edge, sizeof(edge), 0);
for i:= 1 to n do
  begin
  read(f1, edge[i,0]);
  for j:=1 to edge[i,0] do
    begin
    read(f1, a);
    edge[i, j]:= a;
    conn[i, a]:= true; conn[a, i]:= true;
    end;
  readln(f1);
  end;
fillchar(resh, sizeof(resh), false);
end;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
BEGIN
Init;
Solve;
Done;
END.

