Const
        InFile = 'build.inp';
        OutFile = 'build.out';

        MAXH = 11;

Var
        FIn,FOut       : Text;
        w,h            : integer;
        a              : array [0..MAXH+1,0..MAXH+1] of boolean;
        isCompute      : array [1..12,1..12] of boolean;
        compute        : array [1..12,1..12] of longint;
        solution       : longint;

procedure swap(var a,b : integer);
var
   temp : integer;
begin
    temp := a;
    a := b;
    b := temp;
end;

procedure init;
begin
   fillchar(isCompute,sizeof(isCompute),FALSE);
   isCompute[8,8] := TRUE; compute[8,8] := 12988816;
   isCompute[8,7] := TRUE; compute[8,7] := 1292697;
   isCompute[9,8] := TRUE; compute[9,8] := 108435745;
   isCompute[8,6] := TRUE; compute[8,6] := 167089;
   isCompute[10,6] := TRUE; compute[10,6] := 4213133;
   isCompute[9,6] := TRUE; compute[9,6] := 817991;
   isCompute[10,7] := TRUE; compute[10,7] := 53175517;
   isCompute[11,6] := TRUE; compute[11,6] := 21001799;
end;

procedure rec(i,j : integer);
begin
   if i > w then begin
      i := 1;
      j := j + 1;
   end;

   if j > h then
       inc(Solution)
   else begin
      if a[i,j] then
         rec(i+1,j)
      else begin
         if not a[i+1,j] then begin
            a[i,j] := TRUE;
            a[i+1,j] := TRUE;
            rec(i+2,j);
            a[i,j] := FALSE;
            a[i+1,j] := FALSE;
         end;
         if not a[i,j+1] then begin
             a[i,j] := TRUE;
             a[i,j+1] := TRUE;
             rec(i+1,j);
             a[i,j] := FALSE;
             a[i,j+1] := FALSE;
         end;
      end;
   end;
end;

procedure solve;
var
   i,j : integer;
begin

   if w < h then swap(w,h);

   if odd(h) and odd(w) then
       solution := 0
   else begin
      if isCompute[w,h] then
          solution := compute[w,h]
      else begin
          fillchar(a,sizeof(a),TRUE);
          for i := 1 to w do
              for j := 1 to h do
                  a[i,j] := FALSE;
          solution := 0;
          rec(1,1);
      end;
   end;
   writeln(FOut,solution);
end;

Begin
           init;
           assign(FIn,InFile);          reset(FIn);
           assign(FOut,OutFile);        rewrite(FOut);
           readln(FIn,W,H);
           close(FIn);
           solve;
           close(FOut);
End.