#include <stdio.h>
#include <string.h>

int n;
int mat[171][171],mat2[171][171];
int used[171],t;

void Init()
  {
    FILE *f=fopen("routes.inp","rt");
    int br,a,i,j;
    fscanf(f,"%d",&n);
    for(i=1;i<=n;i++)
      {
        fscanf(f,"\n%d",&br);
        for(j=0;j<br;j++)
          {
            fscanf(f,"%d",&a);
            mat[i][a]=1;
            mat[a][i]=1;
          }
      }

    fclose(f);
  }

void DFS(int vr)
  {
    int i;
    used[vr]=1;
    mat2[t][vr]++;
    for(i=1;i<=n;i++)
      if(!used[i] && mat[vr][i]) DFS(i);
    used[vr]=0;
  }

int main()
  {
    int i,j,k;
    Init();
    for(t=1;t<=n;t++)
        DFS(t);
    FILE *f=fopen("routes.out","wt");
    for(i=1;i<=n;i++)
      for(j=i+1;j<=n;j++)
        if(mat[i][j] && mat2[i][j]==1) fprintf(f,"%d %d\n",i,j);
    fclose(f);
    return 0;
  }
