#include <stdio.h>
#include <math.h>

FILE *fn;
int n, rm;
double x[1024], y[1024], r[1024], ans;
double pi, angle;
int zero, ct;

int eq(double a, double b) {
  if (a-b<0.000001 && b-a<0.000001) return 1;
  else return 0;
}

int gt(double a, double b) {
  if (a-b>0.000001) return 1;
  else return 0;
}

int lt(double a, double b) {
  if (b-a>0.000001) return 1;
  else return 0;
}

/*int orient(double x1, double y1, double x2, double y2, double x3, double y3) {
  double orface = (x1*y2+x2*y3+x3*y1)-(x1*y3+x2*y1+x3*y2);
  if (gt(orface, 0)) return 1;
  else if (eq(orface, 0)) return 0;
  else return -1;
}*/

int main(void) {
int i, pnext;
double rb, ry, t1, t2, t3, rdif, pdist;

fn=fopen("fence.inp", "r");
while (!feof(fn)) {
  fscanf(fn, "%lf %lf %lf\n", &x[n], &y[n], &r[n]);
  n++;
}
fclose(fn);

pi=acos(-1);

if (n==1) {
  ans=2*pi*r[0];
} else {
  rm=0;
  rb=x[0]+r[0];
  ry=y[0];
  for (i=1; i<n; i++) {
    if (gt(x[i]+r[i], rb) || (eq(x[i]+r[i], rb) && gt(y[i], ry))) {
      rm=i;
      rb=x[i]+r[i];
      ry=y[i];
    }
  }
  ct=rm;
  while (zero==0 || ct!=rm) {
    zero=1;
    rb=2*pi+angle+1;
    pdist=0;
    for (i=0; i<n; i++) if (i!=ct) {
      t1=(x[ct]-x[i])*(x[ct]-x[i])+(y[ct]-y[i])*(y[ct]-y[i]);
      if (eq(r[ct], r[i])) {
        if (eq(x[ct], x[i])) {
          t2=0;
          t3=pi;
        } else {
          t2=atan((y[ct]-y[i])/(x[ct]-x[i]))+pi/2;
          t3=t2+pi;
        }
        t1=sqrt(t1);
      } else {
        if (gt(r[ct], r[i])) {
          if (eq(x[ct], x[i])) {
            if (y[ct]>y[i]) t2 = 3*pi/2;
            else t2=pi/2;
          } else if (gt(x[ct], x[i])) {
            t2=atan((y[ct]-y[i])/(x[ct]-x[i]))+pi;
          } else {
            t2=atan((y[ct]-y[i])/(x[ct]-x[i]));
          }
        } else {
          if (eq(x[i], x[ct])) {
            if (y[i]>y[ct]) t2 = 3*pi/2;
            else t2=pi/2;
          } else if (gt(x[i], x[ct])) {
            t2=atan((y[i]-y[ct])/(x[i]-x[ct]))+pi;
          } else {
            t2=atan((y[i]-y[ct])/(x[i]-x[ct]));
          }
        }
        rdif=r[ct]-r[i];
        if (rdif<0) rdif*=-1;
        t1=sqrt(t1-rdif*rdif);
        t3=acos(rdif/t1);
        t2=t2-t3;
        t3=2*t3+t2;
      }
      while (t2<angle || eq(t2, angle)) t2+=2*pi;
      while (gt(t2, angle+2*pi)) t2-=2*pi;
      while (t3<angle || eq(t3, angle)) t3+=2*pi;
      while (gt(t3, angle+2*pi)) t3-=2*pi;
      if (lt(t2, rb) || (eq(t2, rb) && t1>pdist)) {
        rb=t2;
        pnext=i;
        pdist=t1;
      }
      if (lt(t3, rb) || (eq(t3, rb) && t1>pdist)) {
        rb=t3;
        pnext=i;
        pdist=t1;
      }
    }
    ans+=(rb-angle)*r[ct];
    ans+=pdist;
    ct=pnext;
    angle=rb;
  }
  ans+=(2*pi-angle)*r[rm];
}

fn=fopen("fence.out", "w");
fprintf(fn, "%.2lf\n", ans);
fclose(fn);

return 0;
}
